StringReader (Java SE 11 & JDK 11 )
Keywords: java.io.StringReader class

Module java.base
Package java.io

## Class StringReader

- java.lang.Object
- - java.io.Reader
  - - java.io.StringReader

- All Implemented Interfaces:
    `Closeable`, `AutoCloseable`, `Readable`

      public class StringReader
      extends Reader

  A character stream whose source is a string.
  Since:
    1.1

- - ### Field Summary

    - ### Fields declared in class java.io.Reader

      `lock`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `StringReader​(String s)` | Creates a new string reader.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` | Closes the stream and releases any system resources associated with it.
    `void` | `mark​(int readAheadLimit)` | Marks the present position in the stream.
    `boolean` | `markSupported()` | Tells whether this stream supports the mark() operation, which it does.
    `int` | `read()` | Reads a single character.
    `int` | `read​(char[] cbuf, int off, int len)` | Reads characters into a portion of an array.
    `boolean` | `ready()` | Tells whether this stream is ready to be read.
    `void` | `reset()` | Resets the stream to the most recent mark, or to the beginning of the string if it has never been marked.
    `long` | `skip​(long ns)` | Skips the specified number of characters in the stream.

    - ### Methods declared in class java.io.Reader

      `nullReader, read, read, transferTo`

    - ### Methods declared in class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### StringReader

          public StringReader​(String s)

      Creates a new string reader.
      Parameters:
        `s` - String providing the character stream.

  - ### Method Detail

    - #### read

          public int read()
                   throws IOException

      Reads a single character.
      Overrides:
        `read` in class `Reader`
      Returns:
        The character read, or -1 if the end of the stream has been reached
      Throws:
        `IOException` - If an I/O error occurs

    - #### read

          public int read​(char[] cbuf,
                          int off,
                          int len)
                   throws IOException

      Reads characters into a portion of an array.
      Specified by:
        `read` in class `Reader`
      Parameters:
        `cbuf` - Destination buffer
        `off` - Offset at which to start writing characters
        `len` - Maximum number of characters to read
      Returns:
        The number of characters read, or -1 if the end of the stream has been reached
      Throws:
        `IOException` - If an I/O error occurs
        `IndexOutOfBoundsException` - If an I/O error occurs

    - #### skip

          public long skip​(long ns)
                    throws IOException

      Skips the specified number of characters in the stream. Returns the number of characters that were skipped.

      The `ns` parameter may be negative, even though the `skip` method of the `Reader` superclass throws an exception in this case. Negative values of `ns` cause the stream to skip backwards. Negative return values indicate a skip backwards. It is not possible to skip backwards past the beginning of the string.

      If the entire string has been read or skipped, then this method has no effect and always returns 0.

      Overrides:
        `skip` in class `Reader`
      Parameters:
        `ns` - The number of characters to skip
      Returns:
        The number of characters actually skipped
      Throws:
        `IOException` - If an I/O error occurs

    - #### ready

          public boolean ready()
                        throws IOException

      Tells whether this stream is ready to be read.
      Overrides:
        `ready` in class `Reader`
      Returns:
        True if the next read() is guaranteed not to block for input
      Throws:
        `IOException` - If the stream is closed

    - #### markSupported

          public boolean markSupported()

      Tells whether this stream supports the mark() operation, which it does.
      Overrides:
        `markSupported` in class `Reader`
      Returns:
        true if and only if this stream supports the mark operation.

    - #### mark

          public void mark​(int readAheadLimit)
                    throws IOException

      Marks the present position in the stream. Subsequent calls to reset() will reposition the stream to this point.
      Overrides:
        `mark` in class `Reader`
      Parameters:
        `readAheadLimit` - Limit on the number of characters that may be read while still preserving the mark. Because the stream's input comes from a string, there is no actual limit, so this argument must not be negative, but is otherwise ignored.
      Throws:
        `IllegalArgumentException` - If `readAheadLimit < 0`
        `IOException` - If an I/O error occurs

    - #### reset

          public void reset()
                     throws IOException

      Resets the stream to the most recent mark, or to the beginning of the string if it has never been marked.
      Overrides:
        `reset` in class `Reader`
      Throws:
        `IOException` - If an I/O error occurs

    - #### close

          public void close()

      Closes the stream and releases any system resources associated with it. Once the stream has been closed, further read(), ready(), mark(), or reset() invocations will throw an IOException. Closing a previously closed stream has no effect. This method will block while there is another thread blocking on the reader.
      Specified by:
        `close` in interface `AutoCloseable`
      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in class `Reader`